<template>
  <div id="teacher_lecture_live_wrapper" class="bt-container" style="height: 100%; width: 1000px">
      <el-breadcrumb style="font-size: 24px; margin-top: 16px; margin-bottom: 32px;" separator=">">
        <el-breadcrumb-item>{{ $t('SGROUP.TITLE') }}</el-breadcrumb-item>
        <el-breadcrumb-item>{{ title }}</el-breadcrumb-item>
      </el-breadcrumb>
      <br/>
    <div style="display:inline; float: right; margin-top:-40px;">   
      <el-button size="small" @click="onClick('BACK')" :class="$attachReactablePostfix('el-btn')">{{ $t('ITEM_FROM_BANK.LEAVE') }}</el-button>
    </div>

    <el-dialog
      :visible.sync="dialogVisible"
      width="30%"
      :before-close="afterSubmitPassword">
      <el-input v-model="password" placeholder="Please enter your room password."></el-input>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="afterSubmitPassword">Confirm</el-button>
      </span>
    </el-dialog>

    <el-button v-if="speakStatus === 0" @click="startSpeak" type="primary">{{ $t('SGROUP.GET_THE_FLOOR') }}</el-button>
    <el-button v-if="speakStatus === 1" @click="endSpeak" type="danger">{{ $t('SGROUP.GIVE_UP_THE_FLOOR') }}</el-button>
    <el-button style="float: right" @click="_cam_mic_test" type="success"> {{ $t('SGROUP.CAMERA_MIC_TEST') }}</el-button>

    <span>
    </span>
    <el-dialog 
      :visible.sync="testDialogVisible"
      width = "40%">
      <span slot="title" style ="font-size:35px; font-weight:600;" ><i class="el-icon-info"></i> {{ $t('SGROUP.CAMERA_MIC_TEST') }} </span>
      <div align="center">  
      <el-row type="flex" class="row-bg" style = "width: 70%;" >
      <el-col :span="20" >
      <div class="grid-content bg-purple"> {{ $t('SGROUP.CAM_IS_CONNECTED') }}</div>
      </el-col>
      <el-col :span="4" >
      <div class="grid-content bg-light">
      <div v-if="hasVideo === true"> 
      <div class="grid-content bg-success">
      <span slot="title" style ="font-size:20px; font-weight:500;">{{ $t('SGROUP.CONNECT') }}</span>
      </div></div>
      <div v-if="hasVideo === false"> 
      <div class="grid-content bg-fail">
      <span slot="title" style ="font-size:20px; font-weight:500;">{{ $t('SGROUP.FAIL') }}</span>
      </div> </div>
      </div>
      </el-col>
      </el-row>
      </div>
      
      <div align="center">
      <el-row type="flex" class="row-bg" style = "width: 70%;">
      <el-col :span="20" ><div class="grid-content bg-purple"> {{ $t('SGROUP.MIC_IS_CONNECTED') }} </div></el-col>
      <el-col :span="4" >
      <div v-if="hasAudio === true">   
        <div class="grid-content bg-success">
            <span slot="title" style ="font-size:20px; font-weight:500;">{{ $t('SGROUP.CONNECT') }}</span>
            </div>
          </div>
        <div v-if="hasAudio === false"> 
        <div class="grid-content bg-fail">
        <span slot="title" style ="font-size:20px; font-weight:500;">{{ $t('SGROUP.FAIL') }}</span>
        </div>
        </div>
        </el-col>
      </el-row>
      
    
      </div>
      <div></div>
          <div style="display: inline-block; width: 100%; margin-top: 10px" align = "center">
          <div v-if="recordingBtnNum === 0" >
            <el-button type="primary" :title="$t('UPLOAD.VOICE_RECORDING')" icon="fa fa-microphone" @click="startRecording(1)"></el-button>
            <span style="margin-left: 10px" slot="tip" class="el-upload__tip"> {{ $t('SGROUP.PRESS_BTN_TO_CHECK_MIC') }}</span>
          </div>
          <div v-if="recordingBtnNum === 1">
            <el-button type="danger" :title="$t('UPLOAD.VOICE_RECORDING')" icon="fa fa-microphone" @click="finishRecording(1)"></el-button>
            <span style="margin-left: 10px"  slot="tip" class="el-upload__tip"> {{ $t('SGROUP.PRESS_BTN_TO_CHECK_MIC') }}</span>
          </div>
          <audio controls :src="questionBlobURL"></audio>
        </div>
        <div><br><br></div>
        <div align="center">
    
          <el-button type="primary" @click="reTestDialog" plain> {{ $t('SGROUP.CHECK_CONNECTION_AGAIN') }} </el-button>
        <el-button type="plain" @click="closeDialog">{{ $t('ITEM.CLOSE')}}</el-button>
        </div>     
    </el-dialog>
    <el-dialog
      :visible.sync="videoSelectorVisible">
      비디오 장치를 선택하세요.
      <el-table
        :data="videoList"
        highlight-current-row
        @current-change="selectVideo">
        <el-table-column property="label" label="장치 이름"></el-table-column>
      </el-table>
    </el-dialog>
    <el-dialog
      :visible.sync="audioSelectorVisible">
      오디오 장치를 선택하세요.
      <el-table
        :data="audioList"
        highlight-current-row
        @current-change="selectAudio">
        <el-table-column property="label" label="장치 이름"></el-table-column>
      </el-table>
    </el-dialog>
    <el-button v-if="muteDefault" @click="muteAll" type="primary">{{ $t('SGROUP.LISTEN_ALL') }}</el-button>
    <el-button v-if="!muteDefault" @click="muteAll" type="danger">{{ $t('SGROUP.MUTE_ALL_EXCEPT_CURRENT_SPEAKER') }}</el-button>

    <span v-if="speakStatus === 2" disabled>{{ $t('SGROUP.IF_YOU_WANT_TO_BE_A_MAIN_SPEAKER_WAIT_UNTIL_CUREENT_SPEAKER_IS_DOWN') }}</span>
    <div style="display: flex; justify-content: center">
      <video v-show="speakStatus !== 0" :muted="speaker.isMute" controls width="1000px" ref="speakerVideo" id="speakerVideo"/>
    </div>
    <div style="display: flex; justify-content: center">
      <span> {{ speaker.name }} </span>
    </div>

    <span style="display:inline-block; width: 200px; text-align:center; position: relative">
      <video :muted="true" controls width="100%" ref="myVideo" id="myVideo"/>
      <span> {{ $t('SGROUP.MY_SCREEN') }} </span>
    </span>

    <span v-for="user in userList" v-bind:key="user.socket_id">
      <span v-show="user.isVisible" style="display:inline-block; width: 200px; text-align:center; position: relative">
        <video :muted="user.isMute" controls width="100%" :ref="user.socket_id" :id="user.socket_id"/>
        <span> {{ user.from_name }} </span>
      </span>
    </span>

    <s-group-chating :room_id="discussionRoomId"></s-group-chating>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex';
import LectureList from '../partials/LectureList';
import SGroupChating from '../partials/SGroupChating';
import utils from '../../utils';
import lectureService from '../../services/lectureService';

export default {
  name: 'SGroupRoom',
  async created() {
    const vm = this;
    
    vm.roomId = vm.$route.params.roomId;
    
    // 다른 방에 접속중인지 , 방에 비밀번호가 걸려있는지 , 방에 들어올 권한이 있는지 검사
    const entrace_check = await lectureService.getEntraceCheck({ roomId: vm.roomId });

    vm.hasPermission = entrace_check.data.hasPermission; // 권한 없는 경우, 체크 끝나면 권한 부여를 위해 저장

    if (entrace_check.data.isDuplicated) { // 다른 방에 접속중이면, 알람주고 내보내기
      vm.$notify({
        message: '당신은 이미 다른 방에 접속중입니다. 여러 방에 동시에 들어갈 수 없습니다.',
        type: 'warning',
      });
      vm.$router.go(-1);
    } else if ( entrace_check.data.hasPermission === false && entrace_check.data.hasPassword === true) { // 권한이 없는 사람이며, 방에 비밀번호가 있으면
      vm.dialogVisible = true;
    } else {
      vm.selectDevices();
    }
    
    // const roomInfo = await lectureService.newgetSmallMeetingRoomList({
    //   classId : vm.classId,
    // });
    // roomInfo.data.forEach(x => {
    //   if(x.room_id == vm.roomId){
    //     targetUser = x.user_id;
    //     vm.room = x;
    //     isIn = true;
    //   }
    // });

    // TODO: 의도치 않은 팅김 현상

    // //URL로 접근한 경우, DB안에 없는 room에 들어갈 때 방지
    // if(!isIn){
    //   vm.$router.push({ name: 'LandingPage' });
    // }
    // vm.title = vm.room.name;
    // var tmp = await lectureService.getPermittedUserList({
    //   roomId : vm.roomId,
    // })
    // vm.authStudents = tmp.data;
    // var isAuth = false;
    // vm.authStudents.forEach(x => {
    //   if(vm.myId === x.user_id){
    //     isAuth = true;
    //   }
    // })
    
    // //권한 없고 학생인 경우
    // if(vm.authStudents.length!=0){
    //   if(!isAuth && vm.mytype === 0){
    //     vm.$router.push({ name: 'LandingPage' });      
    //   }
    // }    
   },
  components: {
    LectureList,
    SGroupChating,
  },
  data() {
    return {
      // webRTC ***********************
      pc: [],
      configuration: {
        iceServers: [
          {
            urls: 'turn:wiseswot.com:3478',
            username: 'test',
            credential: 'test123',
          },
        ],
        iceTransportPolicy: 'relay',
      },
      hasVideo: false, // 접속자 시스템에 비디오, 오디오 여부
      hasAudio: false,
      userList: [],
      recordingBtnNum: 0,
      speaker: {
        socket_id: null,
        email_id: null,
        name: null,
        isMute: false,
        isMe : false, // 나였다가, 내가 아닌 사람이 발언대를 잡는 최초 1회를 감지하기 위해 사용
      },
      recorder:null,
      localStream: undefined,
      heartBeat: undefined, // 발언시 하트비트
      // webRTC ***********************

      dialogVisible: false,
      password: '', // 학생이 입력한 방 비밀번호
      hasPermission: false,
      questionBlobURL: undefined,
      audioBlob: [],
      roomId: 0,     
      room: [],   
      title: '',
      count: 0,
      myId: 0,
      mytype: 0,
      myname: '',  
      authStudents: [],   
      lectureId: this.$router.currentRoute.params.lectureId,
      testDialogVisible: false,
      videoSelectorVisible: false,
      audioSelectorVisible: false,
      muteDefault: false,
      audioList: [],
      videoList: [],
    };
  },
  computed: {
    ...mapState('NNclass', [
      'teachingClassList',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
    discussionRoomId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.roomId, 10);
    },
    speakStatus() {
      const vm = this;      
      if (vm.speaker.email_id === undefined || vm.speaker.email_id === null) { // 아무도 말하지 않는 중
        return 0;
      } else if (vm.speaker.email_id === utils.getEmailFromJwt()) { // 내가 말하는 중
        return 1;
      } else { // 누군가 말하는 중
        return 2;
      }
    },
  },
  methods: {
    ...mapActions('NNclass', [
      'getClass',
      'getMyClassLists',
      'deleteLectureFromClass',
    ]),
    async selectDevices() {
      const vm = this;
      try {  
        await navigator.mediaDevices.getUserMedia({
          audio: true,
          video: true,
        });
      } catch (error) {
        console.error(error);
        console.log('selectDevices의 getUserMedia에서 일부 또는 모든 장치를 발견하지 못함. (처리된 예외)');
      }
      let enumeratorPromise = await navigator.mediaDevices.enumerateDevices();
      vm.videoList = enumeratorPromise.filter(x => x.kind === 'videoinput');
      vm.videoList.push({
        deviceId: null,
        label: '사용 안함',
      });
      vm.audioList = enumeratorPromise.filter(x => x.kind === 'audioinput');
      console.log('vm.audioList = ', vm.audioList);
      // vm.audioList.push({ // 미디어가 완전 없는 경우 처리를 더 해야할 것으로 판단하여 잠금 (연결 순서 관련 문제)
      //   deviceId: null,
      //   label: '사용 안함',
      // });
      vm.videoSelectorVisible = true;
    },
    async closeDialog(){{
      const vm = this;
      vm.testDialogVisible=false;
    }},
    async startSpeak() {
      const vm = this;
      vm.$socket.emit('DISCUSSION_SPEAK' , JSON.stringify({
        startSpeak: true,
        discussion_room_id: vm.discussionRoomId,
        from_email_id: utils.getEmailFromJwt(),
        from_name: utils.getNameFromJwt(),
      }));
    },
    async endSpeak() {
      const vm = this;
      vm.$socket.emit('DISCUSSION_SPEAK' , JSON.stringify({
        endSpeak: true,
        discussion_room_id: vm.discussionRoomId,
      }));
      clearTimeout(vm.heartBeat); // 하트비트 해제
    },
    async reTestDialog(){
      const vm =this;
       vm.testDialogVisible = false;
      vm._cam_mic_test();
      vm.testDialogVisible = true; 
    },
    async startRecording(slotNumber) {
      const vm = this;
      if (vm.hasAudio===false){
        vm.$notify({
          title: vm.$t('NOTIFY.REC_FAIL'),
          message: vm.$t('NOTIFY.RECONFIRM_EQUIP'),
          type: 'error',
          duration: 0,
        });
        return;
      }
      if (vm.recordingBtnNum !== 0) {
        await vm.finishRecording(vm.recordingBtnNum);
      }
      try {
        const stream = await navigator.mediaDevices.getUserMedia({ audio: true }); // 녹음 권한 획득
        vm.recorder = new RecordRTCPromisesHandler(stream, {
          type: 'audio',
        });
        vm.recorder.startRecording();
        vm.recordingBtnNum = 1;
      } catch (error) {
        vm.$notify({
          title: vm.$t('NOTIFY.REC_FAIL'),
          message: vm.$t('NOTIFY.RECONFIRM_EQUIP'),
          type: 'error',
          duration: 0,
        });
      }
    },
    async finishRecording(slotNumber) {
      const vm = this;
      await vm.recorder.stopRecording();
      if (slotNumber === 1) { // 문제에 멀티미디어를 첨부하는 경우
        vm.audioBlob[slotNumber] = await vm.recorder.getBlob();
        vm.questionBlobURL = URL.createObjectURL(vm.audioBlob[slotNumber]);
        vm.questionVoiceFile = new File([vm.audioBlob[slotNumber]], 'voice.webm', { type: 'audio/webm' });
      } 
      vm.recordingBtnNum = 0; // 현재 녹음중인 버튼이 없음을 알림
    },
    async _cam_mic_test(){
      const vm = this; 
      let check_audio = 0;
      let check_video = 0;
      vm.testDialogVisible=true;
      // try {
        const devices = await navigator.mediaDevices.enumerateDevices();
        devices.forEach((device) => {
          if (device.kind === 'videoinput') {
            vm.hasVideo = true;
            check_video = 1;
          }
          if (device.kind === 'audioinput') {
            vm.hasAudio = true;
            check_audio= 1;
          }
        });
        if(check_audio !== 1 ){
          vm.hasAudio = false;
        }
        if(check_video !== 1 ){
          vm.hasVideo = false;
        }
        if(vm.hasAudio === true || vm.hasVideo===true){
        await navigator.mediaDevices.getUserMedia({
          audio: vm.hasAudio,
          video: vm.hasVideo,
        });
        }
      // } catch (err) {
      //   vm.$notify({
      //     title: vm.$t('NOTIFY.TITLE'),
      //     message: vm.$t('REALTIME.FAILED1'),
      //     type: 'warning',
      //   });
      //   return;
      // }
      
    },
    async onClick(type) {
      const vm = this;
      switch (type) {
        case 'BACK': {
          location.href = "javascript:history.back();";
          break;          
        }   
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    muteAll() {
      const vm = this;
      vm.muteDefault = !vm.muteDefault;
      vm.userList.forEach(user => {
        user.isMute = vm.muteDefault;
      })
    },
    async afterSubmitPassword() { // 비밀번호 제출 직후
      const vm = this;
      vm.dialogVisible = false;
      const checkRes = await lectureService.getPasswordCheck({ roomId: vm.roomId, password: vm.password })
      
      if (checkRes.data.correct) { // 방 비밀번호를 맞췄으면
        vm.webRTCConnect();
      } else {
        vm.$notify({
          message: 'password is incorrect.',
          type: 'warning',
        });
        vm.$router.go(-1);
      }
    },
    async webRTCConnect() {
      console.log('@webRTCConnect');
      const vm = this;
      console.log('vm.$socket = ' ,vm.$socket);

      //로그 생성
      await lectureService.postSGroupRoomLog({
        roomId : vm.roomId,
      });
      if (vm.hasPermission === false) { // 권한 생성
        await lectureService.postEntrancePermission({
          roomId: vm.roomId,
          userId: utils.getUserIdFromJwt(),
        })
      }
      // 새로고침, 탭 닫기, 창 닫기 시 소그룹방 퇴장 반영하기 위해 - 200903
      window.onbeforeunload = async function () {
        await lectureService.deleteSGroupRoomLog({
          roomId : vm.roomId,
        });
      };

      window.addEventListener("beforeunload", async function(e) {
        await lectureService.deleteSGroupRoomLog({
          roomId : vm.roomId,
        });
      });

      if(vm.$isPhone) {
        alert('스마트폰으로 접속하였습니다. 모든 상대의 말을 들으려면, 음소거를 해제해주세요. 하울링이 일어난다면, 이어폰을 착용해주세요.');
        vm.muteDefault = true;
      }      
      
      let videoConstraint = {
        deviceId: vm.videoDeviceId,
        frameRate: { ideal: 30, max: 30 },
        width: 320,
        height: 200,
      };
      if (vm.videoDeviceId === null) videoConstraint = false;
      let audioConstraint = {
        deviceId: vm.audioDeviceId,
        echoCancellation: true,
      };
      if (vm.audioDeviceId === null) audioConstraint = false;

      try {
        vm.localStream = await navigator.mediaDevices.getUserMedia({
          video: videoConstraint,
          audio: audioConstraint,
        });
      } catch (error) {
        console.error(error);
        console.log('webRTCConnect의 getUserMedia에서 일부 또는 모든 장치를 발견하지 못함. (처리된 예외)');
      }

      vm.$nextTick(() => {
        if (vm.localStream) {
          const myVideo = vm.$el.querySelector('video[id*="myVideo"]');
          myVideo.srcObject = vm.localStream;
          myVideo.autoplay = true;
        }
      })

      // 입장 사실 서버에 알림
      vm.$socket.emit('DISCUSSION' , JSON.stringify({
        discussion_room_id: vm.discussionRoomId,
        from_email_id: utils.getEmailFromJwt(),
        from_name: utils.getNameFromJwt(),
      }));

      vm.sockets.subscribe('DISCUSSION', async (evt) => {
        const signal = JSON.parse(evt);

        console.log('signal.from_socket_id = ', signal.from_socket_id);
        // 이미 연결된적이 있는 소켓ID인지 찾는다.
        let userIndex = -1;
        vm.userList.forEach((element, index) => {
          if (element.socket_id === signal.from_socket_id) {
            userIndex = index;
          }
        })

        // 이미 연결된 적 있는 email_id인지 찾는다.
        let userMailIndex = -1;
        vm.userList.forEach((element, index) => {
          if (element.from_email_id === signal.from_email_id) {
            userMailIndex = index;
          }
        })

        // 만약 둘이 다르다면, email_id index는 연결이 해제된것으로 판단하고 숨김한다.
        if (userIndex !== userMailIndex) {
          console.log('userIndex = ', userIndex);
          console.log('userMailIndex = ', userMailIndex);
          console.log(userMailIndex + '번째 userList를 숨김 처리합니다.');
          vm.pc[userMailIndex].close();
          vm.userList[userMailIndex].isVisible = false;
          vm.userList[userMailIndex].socket_id = userMailIndex;
        }

        // 만약 소켓 아이디가 저장되지 않았다면, 저장하고 인덱스를 리턴한다.
        if (userIndex === -1) {
          vm.userList.push({ socket_id: signal.from_socket_id, from_name: signal.from_name, from_email_id: signal.from_email_id, isMute: vm.muteDefault, isVisible: true });
          userIndex = vm.userList.length - 1;
        }

        if (signal.call_me || signal.offer) {
          console.log(userIndex, ': on call_me or offer (pc created)');
          vm.pc[userIndex] = new RTCPeerConnection(vm.configuration);
          
          console.log('vm.pc['+userIndex+'].iceConnectionState = ', vm.pc[userIndex].iceConnectionState);

          if (vm.localStream) {
            vm.localStream.getTracks().forEach(track => {
              console.log('@getTracks() track = ', track);
              vm.pc[userIndex].addTrack(track, vm.localStream);
            });
          }

          // Listen for local ICE candidates on the local RTCPeerConnection
          vm.pc[userIndex].addEventListener('icecandidate', event => {
            if (event.candidate) {
              vm.$socket.emit('DISCUSSION', JSON.stringify({
                candidate: event.candidate,
                to_socket_id: signal.from_socket_id,
                from_email_id: utils.getEmailFromJwt(),
                from_name: utils.getNameFromJwt(),
              }));
              console.log('event.candidate = ', event.candidate);
              console.log(userIndex, ': emit icecandidate');
            }
          });

          vm.pc[userIndex].addEventListener('connectionstatechange', event => {
            if (vm.pc[userIndex].connectionState === 'connected') {
              console.log(userIndex, ': peer connected!');
            }
            if (vm.pc[userIndex].connectionState === 'disconnected') {
              console.log(userIndex, ': peer disconnected!');
              vm.pc[userIndex].close();
              vm.userList[userIndex].isVisible = false;
              vm.userList[userIndex].socket_id = userMailIndex;


              // console.log('vm.pc[userIndex] = ', vm.pc[userIndex]);
              // vm.userList.splice(userIndex, 1);
              // vm.pc.splice(userIndex, 1);
              // console.log('vm.userList = ', vm.userList);
              // console.log('vm.pc = ', vm.pc);
            }
          });

          vm.pc[userIndex].addEventListener('icegatheringstatechange', event => {
            console.log('vm.pc['+userIndex+'].iceGatheringState = ', vm.pc[userIndex].iceGatheringState);
          })

          vm.pc[userIndex].addEventListener('iceconnectionstatechange', event => {
            console.log('vm.pc['+userIndex+'].iceConnectionState = ', vm.pc[userIndex].iceConnectionState);
            // if ( vm.pc[userIndex].iceConnectionState === "failed" || vm.pc[userIndex].iceConnectionState === "disconnected") {
            //   console.log('@restartIce');
            //   vm.pc[userIndex].restartIce();
            // }
          })

          const remoteStream = new MediaStream();

          vm.pc[userIndex].addEventListener('track', async (event) => {
            console.log(userIndex, ': on track ☆');
            remoteStream.addTrack(event.track, remoteStream);
            
            vm.$nextTick(() => {
              let targetVideo = vm.$el.querySelector('video[id*="'+signal.from_socket_id+'"]');
              targetVideo.srcObject = remoteStream;
              targetVideo.autoplay = true;

              if (vm.speaker.socket_id === signal.from_socket_id) {
                vm.$el.querySelector('video[id*="speakerVideo"]').srcObject = remoteStream;
              }
            })
          });
        }

        if (signal.call_me) {
          console.log(userIndex, ': on call_me');
          const offer = await vm.pc[userIndex].createOffer();
          await vm.pc[userIndex].setLocalDescription(offer);
          
          vm.$socket.emit('DISCUSSION' , JSON.stringify({
            to_socket_id: signal.from_socket_id,
            from_email_id: utils.getEmailFromJwt(),
            from_name: utils.getNameFromJwt(),
            offer,
          }));
          console.log(userIndex, ': emit offer');
        }

        if (signal.offer) {
          console.log(userIndex, ': on offer');
          vm.pc[userIndex].setRemoteDescription(new RTCSessionDescription(signal.offer));
          const answer = await vm.pc[userIndex].createAnswer();
          vm.$socket.emit('DISCUSSION', JSON.stringify({
            to_socket_id: signal.from_socket_id,
            from_email_id: utils.getEmailFromJwt(),
            from_name: utils.getNameFromJwt(),
            answer,
          }));
          console.log(userIndex, ': emit answer');
          await vm.pc[userIndex].setLocalDescription(answer);
        }
        if (signal.answer) {
          console.log(userIndex, ': on answer');
          console.log('signal.from_socket_id = ', signal.from_socket_id);
          const remoteDesc = new RTCSessionDescription(signal.answer);
          await vm.pc[userIndex].setRemoteDescription(remoteDesc);
        }
        if (signal.candidate) {
          try {
            await vm.pc[userIndex].addIceCandidate(signal.candidate);
            console.log(userIndex, ' : add icecandidate');
          } catch (e) {
            console.log(userIndex, ': Error adding received ice candidate');
            console.error(userIndex, ': Error adding received ice candidate', e);
          }
        }
      });

      vm.sockets.subscribe('DISCUSSION_SPEAK', async (evt) => {
        const signal = JSON.parse(evt);
        vm.speaker.socket_id = signal.speaker_socket_id;
        vm.speaker.email_id = signal.speaker_email_id;
        vm.speaker.name = signal.speaker_name;

        // 발언자가 나인지 검사
        if (utils.getEmailFromJwt() === signal.speaker_email_id) {
          vm.speaker.isMe = true;
          vm.speaker.isMute = true;
          // vm.$refs.speakerVideo.srcObject = vm.$refs.myVideo.srcObject;
          // vm.$refs.speakerVideo.autoplay = true;

          vm.$nextTick(() => {
            //최대 3초간 대기하며 재시도
            for (let i = 0 ; i < 3 ; i += 1) {
              let targetVideo = vm.$el.querySelector('video[id*="'+signal.from_socket_id+'"]');
              let speakerVideo = vm.$el.querySelector('video[id*="speakerVideo"]');
              if (targetVideo && speakerVideo) {
                speakerVideo.srcObject = targetVideo.srcObject;
                speakerVideo.autoplay = true;
                break;
              }
              console.log(signal.from_socket_id, ' 비디오를 찾지못하여 재시도합니다. i = ', i);
              vm.sleep(1000);
            }
            // vm.$el.querySelector('video[id*="speakerVideo"]').srcObject = vm.$el.querySelector('video[id*="myVideo"]').srcObject;
            // vm.$el.querySelector('video[id*="speakerVideo"]').autoplay = true;
          })

          vm.heartBeat = setInterval(() => { // 3초 마다 하트비트 전송
            vm.$socket.emit('DISCUSSION_SPEAK', JSON.stringify({
              heartBeat: true,
              discussion_room_id: vm.discussionRoomId,
            }));
          }, 3000);
        }

        // 이미 연결된적이 있는 유저중에 검사
        let userIndex = -1;
        vm.userList.forEach((element, index) => {
          // if (element.email_id === signal.from_email_id) {
          if (element.socket_id === signal.speaker_socket_id) {
            userIndex = index;
          }
        })
        if (userIndex !== -1) {
          if(vm.speaker.isMe) { vm.speaker.isMute = false; } // 내가 발언권을 갖고, 이후에 다른사람이 발언권을 갖게되는 최초 1회에 한해 mute 해제
          vm.speaker.isMe = false;
          vm.$nextTick(() => {
            // vm.$el.querySelector('video[id*="speakerVideo"]').srcObject = vm.$el.querySelector('video[id*="'+signal.speaker_socket_id+'"]').srcObject;
            // vm.$el.querySelector('video[id*="speakerVideo"]').autoplay = true;
            for (let i = 0 ; i < 3 ; i += 1) {
              let targetVideo = vm.$el.querySelector('video[id*="'+signal.from_socket_id+'"]');
              let speakerVideo = vm.$el.querySelector('video[id*="speakerVideo"]');
              if (targetVideo && speakerVideo) {
                speakerVideo.srcObject = targetVideo.srcObject;
                speakerVideo.autoplay = true;
                break;
              }
              console.log(signal.from_socket_id, ' 비디오를 찾지못하여 재시도합니다. i = ', i);
              vm.sleep(1000);
            }
          })
        }

        // 연결 종료시 null 표시
        if (signal.endSpeak) {
          vm.$refs.speakerVideo.srcObject = null;
          clearTimeout(vm.heartBeat); // 하트비트 해제
        }

        //TODO: 한 계정으로 방에 나갔다 들어오면, singal이 비어있는 DISCUSSION 신호가 잡히는데, 왜 그런지 모르겠음. 조사 필요
      })
    },
    async selectVideo(arg) {
      const vm = this;
      vm.videoDeviceId = arg.deviceId;
      vm.videoSelectorVisible = false;
      vm.audioSelectorVisible = true;
    },
    async selectAudio(arg) {
      const vm = this;
      vm.audioDeviceId = arg.deviceId;
      vm.audioSelectorVisible = false;
      vm.webRTCConnect();
    },
    sleep (delay) {
      var start = new Date().getTime();
      while (new Date().getTime() < start + delay);
    },
  },
  async beforeDestroy() {
    console.log('@beforeDestroy');
    const vm = this;
    
    await lectureService.deleteSGroupRoomLog({
      roomId : vm.roomId,
    });
    
    // //vm.$socket.close(); // 소켓 연결 해제

    if (vm.localStream) {
      vm.localStream.getTracks().forEach((track) => { // 비디오, 오디오 수집 중지
        track.stop();
      })
    }

    vm.pc.forEach((pc) => { // pc 연결 해제
      console.log('pc.foreach pc = ', pc);
      pc.close();
    })

    console.log('vm.pc = ',vm.pc);
  }, 
};
</script>         

<style>
  .el-row {
    margin-bottom: 30px;
    
  }
  .el-col {
    border-radius: 4px;
  }
  .bg-purple-dark {
    background: #99a9bf;
  }
  .bg-success{
    padding:5px 0;
    background: #b6f3d1;
    line-height:40px;
    font-weight: 900;
    font-size: 25px;
    color:#34ce16;
  }
  .bg-fail{
    padding:5px 0;
    background: #fa9090;
    line-height:40px;
    font-weight: 900;
    font-size: 25px;
    color:#e01818;
  }
  .bg-purple {
    padding:5px 0;
    background: #2525258a;
    text-align:center;
    line-height:40px;
    font-weight: 900;
    font-size: 25px;
    color:#ffffff;
  }
  .bg-purple-light {
    background: #e5e9f2;
  }
  .grid-content {
    border-radius: 4px;
    min-height: 46px;
  }
  .row-bg {
    padding: 5px 0;
    background-color: #ffffff00;
  }
</style>
</script>
